<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head><title>Rot-irgendwas-de- und encoder</title>
<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">
<style type="text/css">
body
{
font-family:arial, helvetica, sans;
font-size:0.9em;
margin:12px;
font-weight:100;
background-color:#eeeeee;
}

strong
{
font-weight:800;
}

h1
{
font-weight:800;
font-size:1.7em;
margin-bottom:0.5em;
margin-top:0em;
}

h2
{
font-weight:600;
font-size:1.4em;
margin-bottom:0.2em;
margin-top:0em;
}
</style>
</head>
<body>
<div align="center">
<?php
class rot13
{
function rot13encode($string,$verschieben)
{
$x=0;
if (($verschieben < 0) || ($verschieben > 25))
{
echo "Der Verschieben-Wert mu&szlig; zwischen 0 und 25 liegen.<br>";
return false;
}
if (empty($string)) return false;
$laenge = strlen($string);
for ($this->x=0;$x<$laenge;$x++)
{
$zeichen = substr($string,$x,1);
$wert = ord($zeichen);
if (($wert >=65) && ($wert <= 90))
{
$encoded=$wert+$verschieben;
if ($encoded > 90) $encoded = $encoded - 26;
echo chr($encoded);
// 65 - 90 A-Z
}

elseif (($wert >=97) && ($wert <= 122))
{
$encoded=$wert+$verschieben;
if ($encoded > 122) $encoded = $encoded - 26;
echo chr($encoded);
// 97 - 122 a-z
}
else echo $zeichen;
}
}

function rot13decode($string,$verschieben)
{
if (($verschieben < 0) || ($verschieben > 25))
{
echo "Der Verschieben-Wert mu&szlig; zwischen 0 und 25 liegen.<br>";
return false;
}
if (empty($string)) return false;
$laenge = strlen($string);
for ($x=0;$x<$laenge;$x++)
{
$zeichen = substr($string,$x,1);
$wert = ord($zeichen);
if (($wert >=65) && ($wert <= 90))
{
$encoded=$wert-$verschieben;
if ($encoded < 65) $encoded = $encoded + 26;
echo chr($encoded);
}
elseif (($wert >=97) && ($wert <= 122))
{
$encoded=$wert-$verschieben;
if ($encoded < 97) $encoded = $encoded + 26;
echo chr($encoded);
}
else echo $zeichen;
}
}
}
?>
<div style="text-align:left;padding:0.5em;border:1px solid #bbbbbb; width:80%;margin-bottom:5em;"><h1>Rot-irgendwas-de/encoder</h1>
<p><strong>Qnf uvre vfg rva Ebg13-Grkg.</strong><br>
Sie wollten schon immer wissen, was solch ein Buchstabensalat bedeuten kann?<br>Im Usenet hat sich zum &bdquo;verschl&uuml;sseln&rdquo; von Texten, die nicht gleich f&uuml;r Jedermann lesbar sein sollen, die sogenannte &bdquo;Rot-13&rdquo;-Methode eingeb&uuml;rgert. Dabei wird einfach der Ascii-Wert jedes Buchstaben um 13 Stellen verschoben, nicht jedoch der von Zahlen und Sonderzeichen (darunter fallen auch Satzzeichen und Umlaute). Aus dem A wird so z.B. ein N, aus dem b ein o und so weiter. Ist bei dem Verschieben das z erreicht geht&acute;s wieder von vorne bei a los.</p>
<p>
Jeder g&auml;ngige Newsreader verf&uuml;gt &uuml;ber eine entsprechende Funktion, mit der man solche Texte erstellen und auch wieder lesbar machen kann. Falls Ihr Newsclient das nicht kann k&ouml;nnen Sie auch diese Seite zum ver- und entschl&uuml;sseln Ihrer Texte benutzen.</p>
<p>Geben Sie einfach Ihren Text in das Feld unten ein (ggf. per copy&acute;n&acute;paste) und klicken auf &bdquo;encode&rdquo; zum ver- und &bdquo;decode&rdquo; zum entschl&uuml;sseln. Voreingestellt ist Rot-13. Sie k&ouml;nnen im Feld &bdquo;Code&rdquo; aber auch einen anderen Code w&auml;hlen &ndash; diese Seite kann neben dem Standard Rot-13 auch Gr&uuml;n 4, Gelb 19, Grau 22 und Lila 7 (sowie alle anderen 20 bunten Codecs ;) ).<br>Das jeweilige Ergebnis bekommen Sie dann ganz unten angezeigt.</p>
<form name="rotirgendwas" method="post" action="<?php $php_self;?>">
<textarea style="float:left;margin-right:12px;" name="input" cols="80" rows="5"><?php if (!empty($_POST['input'])) echo $_POST['input']; ?></textarea><br><br>
Code: <select name="verschieben">
<?php
for ($x=1; $x<26; $x++)
{
echo "<option value=\"$x\"";
if (!empty($_POST['verschieben']))
{
if ($x==$_POST['verschieben']) echo " selected";
}
elseif ($x==13) echo " selected";
echo ">$x</option>\n";
}
?>
</select>
<div style="clear:both;">
<input name="aktion" type="submit" value="encode"> | <input name="aktion" type="submit" value="decode">
</div>
</form>
<?php
if (!empty($_POST['input']))
{
$codec = new rot13;
if ($_POST['aktion']=="encode") {
echo "<div style=\"text-align:left;padding:0.5em;background-color:#ffeeee;border: 1px solid #eecccc;\">";
echo "<h2>Mit Rot".$_POST['verschieben']." verschl&uuml;sselt:</h2>";
}
else {
echo "<div style=\"text-align:left;padding:0.5em;background-color:#eeffee;border: 1px solid #cceecc;\">";
echo "<h2>Ursprungstext vor Rot".$_POST['verschieben']." Verschl&uuml;sselung:</h2>";
}

if ($_POST['aktion']=="encode") $codec->rot13encode($_POST['input'],$_POST['verschieben']);
else $codec->rot13decode($_POST['input'],$_POST['verschieben']);
echo "</div>";
}
?>
&larr; <a href="../index.php">zur&uuml;ck zum Index</a>
</div>
</div>
</body>
</html>
